# Based off the spec file from Fedora dhcp-4.1.0p1-8.fc12

# vendor string (e.g., Fedora, EL)
%define vvendor Rutgers

# Where dhcp configuration files are stored
%define dhcpconfdir %{_sysconfdir}/dhcp

# Base version number from ISC
%define basever 4.1.0

# LDAP patch version
%define ldappatchver %{basever}-5

Summary:  Dynamic host configuration protocol software
Name:     dhcp-ldapresnet
Version:  %{basever}p1
Release:  1.ru
# NEVER CHANGE THE EPOCH on this package.  The previous maintainer (prior to
# dcantrell maintaining the package) made incorrect use of the epoch and
# that's why it is at 12 now.  It should have never been used, but it was.
# So we are stuck with it.
Epoch:    12
License:  ISC
Group:    System Environment/Daemons
URL:      http://isc.org/products/DHCP/
Source0:  ftp://ftp.isc.org/isc/dhcp/dhcp-%{version}.tar.gz
Source1:  http://cloud.github.com/downloads/dcantrell/ldap-for-dhcp/ldap-for-dhcp-%{ldappatchver}.tar.gz
Source2:  dhcpd.init
Source3:  dhcrelay.init
Source4:  dhclient-script
Source5:  README.dhclient.d
Source6:  10-dhclient
Source7:  56dhclient

Patch0:   dhcp-4.1.0-errwarn-message.patch
Patch1:   dhcp-4.1.0-memory.patch
Patch2:   dhcp-4.1.0-options.patch
Patch3:   dhcp-4.1.0-release-by-ifup.patch
Patch4:   dhcp-4.1.0-dhclient-decline-backoff.patch
Patch5:   dhcp-4.1.0-unicast-bootp.patch
Patch6:   dhcp-4.1.0-failover-ports.patch
Patch7:   dhcp-4.1.0-dhclient-usage.patch
Patch8:   dhcp-4.1.0-default-requested-options.patch
Patch9:   dhcp-4.1.0-xen-checksum.patch
Patch10:  dhcp-4.1.0-dhclient-anycast.patch
Patch11:  dhcp-4.1.0-manpages.patch
Patch12:  dhcp-4.1.0-paths.patch
#Patch13:  dhcp-4.1.0-CLOEXEC.patch
Patch14:  dhcp-4.1.0-inherit-leases.patch
Patch15:  dhcp-4.1.0-garbage-chars.patch
Patch16:  dhcp-4.1.0-port-validation.patch
Patch17:  dhcp-4.1.0-invalid-dhclient-conf.patch
Patch18:  dhcp-4.1.0-missing-ipv6-not-fatal.patch
#Patch19:  dhcp-4.1.0-IFNAMSIZ.patch
Patch20:  dhcp-4.1.0-add_timeout_when_NULL.patch
Patch21:  dhcp-4.1.0-64_bit_lease_parse.patch
Patch22:  dhcp-4.1.0-CVE-2009-1892.patch
Patch23:  dhcp-4.1.0p1-capability.patch

# Resnet patch
Patch201: dhcp-4.1.0p1-resnet.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: groff
BuildRequires: libtool
BuildRequires: %{_lib}ldap2.4_2-devel
BuildRequires: openssl-devel
BuildRequires: libcap-devel

Requires(post): chkconfig
Requires(post): coreutils
Requires(preun): chkconfig
Requires(preun): initscripts
Requires(postun): initscripts

Provides: dhcp

%description
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows
individual devices on an IP network to get their own network
configuration information (IP address, subnetmask, broadcast address,
etc.) from a DHCP server. The overall purpose of DHCP is to make it
easier to administer a large network.  The dhcp package includes the
ISC DHCP service and relay agent.

To use DHCP on your network, install a DHCP service (or relay agent),
and on clients run a DHCP client daemon.  The dhcp package provides
the ISC DHCP service and relay agent.

%package -n dhclient-ldapresnet
Summary: Provides the dhclient ISC DHCP client daemon and dhclient-script
Group: System Environment/Base
Requires: initscripts >= 6.75
Requires(post): coreutils
Requires(post): grep
Obsoletes: libdhcp4client-ldapresnet
Provides:  dhclient

%description -n dhclient-ldapresnet
DHCP (Dynamic Host Configuration Protocol) is a protocol which allows
individual devices on an IP network to get their own network
configuration information (IP address, subnetmask, broadcast address,
etc.) from a DHCP server. The overall purpose of DHCP is to make it
easier to administer a large network.

To use DHCP on your network, install a DHCP service (or relay agent),
and on clients run a DHCP client daemon.  The dhclient package
provides the ISC DHCP client daemon.

%package devel
Summary: Development headers and libraries for interfacing to the DHCP server
Group: Development/Libraries
Requires: dhcp-ldapresnet = %{epoch}:%{version}-%{release}
Obsoletes: libdhcp4client-ldapresnet-devel
Provides: dhcp-devel

%description devel
Header files and API documentation for using the ISC DHCP libraries.  The
libdhcpctl and libomapi static libraries are also included in this package.

%prep
%setup -q -n dhcp-%{version}
%setup -T -D -a 1 -n dhcp-%{version}

# Add in LDAP support
%{__patch} -p1 < ldap-for-dhcp-%{ldappatchver}/dhcp-%{basever}-ldap.patch

# Replace the standard ISC warning message about requesting help with an
# explanation that this is a patched build of ISC DHCP and bugs should be
# reported through bugzilla.redhat.com
%patch0 -p1

# Fix memory alignment and initialization problems in common/packet.c
# Fix buffer overflow in minires library
# Init struct sock_prog in common/lpf.c to NULL
%patch1 -p1

# Add more dhclient options (-I, -B, -H, -F, -timeout, -V, and -R)
%patch2 -p1

# Handle releasing interfaces requested by /sbin/ifup
# pid file is assumed to be /var/run/dhclient-$interface.pid
%patch3 -p1

# If we receive a DHCP offer in dhclient and it's DECLINEd in dhclient-script,
# backoff for an amount of time before trying again
%patch4 -p1

# Support unicast BOOTP for IBM pSeries systems (and maybe others)
# (Submitted to dhcp-bugs@isc.org - [ISC-Bugs #19146])
%patch5 -p1

# Use the following IANA-registered failover ports:
# dhcp-failover 647/tcp
# dhcp-failover 647/udp
# dhcp-failover 847/tcp
# dhcp-failover 847/udp
%patch6 -p1

# Update the usage screen for dhclient(8) indicating new options
# Use printf() rather than log_info() to display the information
# Also, return EXIT_FAILURE when the usage() screen is displayed (stop parsing)
%patch7 -p1

# Add NIS domain, NIS servers, and NTP servers to the list of default
# requested DHCP options
%patch8 -p1

# Handle Xen partial UDP checksums
%patch9 -p1

# Add anycast support to dhclient (for OLPC)
%patch10 -p1

# Patch man page contents
%patch11 -p1

# Change paths to conform to our standards
%patch12 -p1

# schubert 09/29/09: O_CLOEXEC not available on CentOS 5
#%patch13 -p1

# If we have an active lease, do not down the interface (#453982)
%patch14 -p1

# Fix 'garbage in format string' error (#450042)
%patch15 -p1

# Validate port numbers specified for dhclient, dhcpd, and dhcrelay
# to make sure they are within 1-65535, inclusive.  (#438149)
# (Submitted to dhcp-bugs@isc.org - [ISC-Bugs #18695])
%patch16 -p1

# The sample dhclient.conf should say 'supersede domain-search' (#467955)
# (Submitted to dhcp-bugs@isc.org - [ISC-Bugs #19147])
%patch17 -p1

# If the ipv6 kernel module is missing, do not segfault
# (Submitted to dhcp-bugs@isc.org - [ISC-Bugs #19367])
%patch18 -p1

# schubert 09/29/09: This is effected by the resnet patch
#%patch19 -p1

# Handle cases in add_timeout() where the function is called with a NULL
# value for the 'when' parameter
# (Submitted to dhcp-bugs@isc.org - [ISC-Bugs #19867])
%patch20 -p1

# Ensure 64-bit platforms parse lease file dates & times correctly (#448615)
%patch21 -p1

# Fix for CVE-2009-1892 (patch from Mandriva SRPM)
# http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2009-1892
%patch22 -p1

# Drop unnecessary capabilities in dhclient (#517649)
%patch23 -p1

# Apply resnet patch
%patch201 -p1

# Copy in documentation and example scripts for LDAP patch to dhcpd
%{__install} -p -m 0755 ldap-for-dhcp-%{ldappatchver}/dhcpd-conf-to-ldap contrib/

# Copy in the Fedora/RHEL dhclient script
%{__install} -p -m 0755 %{SOURCE4} client/scripts/linux
%{__install} -p -m 0644 %{SOURCE5} .

# Ensure we don't pick up Perl as a dependency from the scripts and modules
# in the contrib directory (we copy this to /usr/share/doc in the final
# package).
%{__cp} -pR contrib __fedora_contrib
pushd __fedora_contrib
%{__chmod} -x 3.0b1-lease-convert dhclient-tz-exithook.sh dhcpd-conf-to-ldap
%{__chmod} -x sethostname.sh solaris.init
%{__mv} ms2isc/Registry.pm ms2isc/Registry.perlmodule
%{__rm} -f dhcp.spec

# We want UNIX-style line endings
%{__sed} -i -e 's/\r//' ms2isc/readme.txt
%{__sed} -i -e 's/\r//' ms2isc/Registry.perlmodule
%{__sed} -i -e 's/\r//' ms2isc/ms2isc.pl
popd

# Filter false positive perl requires (all of them)
%{__cat} << EOF > %{name}-req
#!/bin/sh
%{__perl_requires} \
| %{__grep} -v 'perl('
EOF
%define __perl_requires %{_builddir}/dhcp-%{version}/%{name}-req
%{__chmod} +x %{__perl_requires}

# Replace @PRODUCTNAME@
%{__sed} -i -e 's|@PRODUCTNAME@|%{vvendor}|g' common/dhcp-options.5
%{__sed} -i -e 's|@PRODUCTNAME@|%{vvendor}|g' configure.ac

# Update paths in all man pages
for page in client/dhclient.conf.5 client/dhclient.leases.5 \
            client/dhclient-script.8 client/dhclient.8 ; do
    %{__sed} -i -e 's|CLIENTBINDIR|/sbin|g' \
                -e 's|RUNDIR|%{_localstatedir}/run|g' \
                -e 's|DBDIR|%{_localstatedir}/db/dhclient|g' \
                -e 's|ETCDIR|%{dhcpconfdir}|g' $page
done

for page in server/dhcpd.conf.5 server/dhcpd.leases.5 server/dhcpd.8 ; do
    %{__sed} -i -e 's|CLIENTBINDIR|/sbin|g' \
                -e 's|RUNDIR|%{_localstatedir}/run|g' \
                -e 's|DBDIR|%{_localstatedir}/db/dhcpd|g' \
                -e 's|ETCDIR|%{dhcpconfdir}|g' $page
done

aclocal
libtoolize --copy --force
autoconf
autoheader
automake --foreign --add-missing --copy

%build
CFLAGS="%{optflags} -fPIC -D_GNU_SOURCE -DDEBUG_LDAP -DRESNET" \
%configure \
    --enable-dhcpv6 \
    --with-srv-lease-file=%{_localstatedir}/lib/dhcpd/dhcpd.leases \
    --with-srv6-lease-file=%{_localstatedir}/lib/dhcpd/dhcpd6.leases \
    --with-cli-lease-file=%{_localstatedir}/lib/dhclient/dhclient.leases \
    --with-cli6-lease-file=%{_localstatedir}/lib/dhclient/dhclient6.leases \
    --with-srv-pid-file=%{_localstatedir}/run/dhcpd.pid \
    --with-srv6-pid-file=%{_localstatedir}/run/dhcpd6.pid \
    --with-cli-pid-file=%{_localstatedir}/run/dhclient.pid \
    --with-cli6-pid-file=%{_localstatedir}/run/dhclient6.pid \
    --with-relay-pid-file=%{_localstatedir}/run/dhcrelay.pid \
    --with-ldap \
    --with-ldapcrypto
%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}
%{__make} install DESTDIR=%{buildroot}

# Remove files we don't want
%{__rm} -f %{buildroot}%{_sysconfdir}/dhclient.conf
%{__rm} -f %{buildroot}%{_sysconfdir}/dhcpd.conf

# Install correct dhclient-script
%{__mkdir} -p %{buildroot}/sbin
%{__mv} %{buildroot}%{_sbindir}/dhclient %{buildroot}/sbin/dhclient
%{__install} -p -m 0755 client/scripts/linux %{buildroot}/sbin/dhclient-script

# Install init scripts
%{__mkdir} -p %{buildroot}%{_initrddir}
%{__install} -p -m 0755 %{SOURCE2} %{buildroot}%{_initrddir}/dhcpd
%{__install} -p -m 0755 %{SOURCE3} %{buildroot}%{_initrddir}/dhcrelay

# Start empty lease databases
%{__mkdir} -p %{buildroot}%{_localstatedir}/lib/dhcpd/
touch %{buildroot}%{_localstatedir}/lib/dhcpd/dhcpd.leases
touch %{buildroot}%{_localstatedir}/lib/dhcpd/dhcpd6.leases
%{__mkdir} -p %{buildroot}%{_localstatedir}/lib/dhclient/

# Create default sysconfig files for dhcpd and dhcrelay
%{__mkdir} -p %{buildroot}%{_sysconfdir}/sysconfig

%{__cat} << EOF > %{buildroot}%{_sysconfdir}/sysconfig/dhcrelay
# Command line options here
INTERFACES=""
DHCPSERVERS=""
EOF

%{__cat} <<EOF > %{buildroot}%{_sysconfdir}/sysconfig/dhcpd
# Command line options here
DHCPDARGS=
EOF

# Copy sample conf files into position (called by doc macro)
%{__cp} -p client/dhclient.conf dhclient.conf.sample
%{__cp} -p server/dhcpd.conf dhcpd.conf.sample

# Install default (empty) dhcpd.conf:
%{__mkdir} -p %{buildroot}%{dhcpconfdir}
%{__cat} << EOF > %{buildroot}%{dhcpconfdir}/dhcpd.conf
#
# DHCP Server Configuration file.
#   see /usr/share/doc/dhcp*/dhcpd.conf.sample
#   see 'man 5 dhcpd.conf'
#
EOF

# Install dhcp.schema for LDAP configuration
%{__mkdir} -p %{buildroot}%{_sysconfdir}/openldap/schema
%{__install} -p -m 0644 -D ldap-for-dhcp-%{ldappatchver}/dhcp.schema \
    %{buildroot}%{_sysconfdir}/openldap/schema

# Install empty directory for dhclient.d scripts
%{__mkdir} -p %{buildroot}%{dhcpconfdir}/dhclient.d

# Install NetworkManager dispatcher script
%{__mkdir} -p %{buildroot}%{_sysconfdir}/NetworkManager/dispatcher.d
%{__install} -p -m 0755 %{SOURCE6} %{buildroot}%{_sysconfdir}/NetworkManager/dispatcher.d

# Install pm-utils script to handle suspend/resume and dhclient leases
%{__mkdir} -p %{buildroot}%{_libdir}/pm-utils/sleep.d
%{__install} -p -m 0755 %{SOURCE6} %{buildroot}%{_libdir}/pm-utils/sleep.d

%clean
%{__rm} -rf %{buildroot}

%post
sampleconf="#
# DHCP Server Configuration file.
#   see /usr/share/doc/dhcp*/dhcpd.conf.sample
#   see 'man 5 dhcpd.conf'
#"

contents="$(/bin/cat %{dhcpconfdir}/dhcpd.conf)"
prevconf="%{_sysconfdir}/dhcpd.conf"

if [ ! -z "${prevconf}" ]; then
    if [ ! -f %{dhcpconfdir}/dhcpd.conf -o "${sampleconf}" = "${contents}" ]; then
        /bin/cp -a ${prevconf} %{dhcpconfdir}/dhcpd.conf >/dev/null 2>&1
        if [ -x /sbin/restorecon ]; then
            /sbin/restorecon %{dhcpconfdir}/dhcpd.conf >/dev/null 2>&1
        fi
    fi
fi

/sbin/chkconfig --add dhcpd
/sbin/chkconfig --add dhcrelay || :

%post -n dhclient-ldapresnet
/bin/ls -1 %{_sysconfdir}/dhclient* >/dev/null 2>&1
if [ $? = 0 ]; then
    /bin/ls -1 %{_sysconfdir}/dhclient* | \
    /bin/grep -v "\.rpmsave$" 2>/dev/null | \
    while read etcfile ; do
        cf="$(/bin/basename ${etcfile})"
        if [ -f ${etcfile} ] && [ ! -r %{dhcpconfdir}/${cf} ]; then
            /bin/cp -a ${etcfile} %{dhcpconfdir}/${cf} >/dev/null 2>&1
            if [ -x /sbin/restorecon ]; then
                /sbin/restorecon %{dhcpconfdir}/${cf} >/dev/null 2>&1
            fi
        fi
    done || :
fi || :

%preun
if [ $1 = 0 ]; then
    /sbin/service dhcpd status >/dev/null 2>&1
    if [ $? = 3 ]; then
        /sbin/service dhcpd stop >/dev/null 2>&1
    fi

    /sbin/service dhcrelay status >/dev/null 2>&1
    if [ $? = 3 ]; then
        /sbin/service dhcrelay stop >/dev/null 2>&1
    fi

    /sbin/chkconfig --del dhcpd
    /sbin/chkconfig --del dhcrelay || :
fi

%postun
if [ $1 -ge 1 ]; then
    /sbin/service dhcpd condrestart >/dev/null 2>&1
    /sbin/service dhcrelay condrestart >/dev/null 2>&1 || :
fi

%files
%defattr(-,root,root,-)
%doc LICENSE README ldap-for-dhcp-%{ldappatchver}/README.ldap
%doc RELNOTES dhcpd.conf.sample doc/IANA-arp-parameters doc/api+protocol
%doc doc/*.txt __fedora_contrib/* ldap-for-dhcp-%{ldappatchver}/*.txt
%dir %{_localstatedir}/lib/dhcpd
%attr(0750,root,root) %dir %{dhcpconfdir}
%verify(not size md5 mtime) %config(noreplace) %{_localstatedir}/lib/dhcpd/dhcpd.leases
%verify(not size md5 mtime) %config(noreplace) %{_localstatedir}/lib/dhcpd/dhcpd6.leases
%config(noreplace) %{_sysconfdir}/sysconfig/dhcpd
%config(noreplace) %{_sysconfdir}/sysconfig/dhcrelay
%config(noreplace) %{dhcpconfdir}/dhcpd.conf
%config(noreplace) %{_sysconfdir}/openldap/schema/dhcp.schema
%dir %{_sysconfdir}/NetworkManager
%dir %{_sysconfdir}/NetworkManager/dispatcher.d
%{_sysconfdir}/NetworkManager/dispatcher.d/10-dhclient
%{_initrddir}/dhcpd
%{_initrddir}/dhcrelay
%{_bindir}/omshell
%{_sbindir}/dhcpd
%{_sbindir}/dhcrelay
%attr(0644,root,root) %{_mandir}/man1/omshell.1.gz
%attr(0644,root,root) %{_mandir}/man5/dhcpd.conf.5.gz
%attr(0644,root,root) %{_mandir}/man5/dhcpd.leases.5.gz
%attr(0644,root,root) %{_mandir}/man8/dhcpd.8.gz
%attr(0644,root,root) %{_mandir}/man8/dhcrelay.8.gz
%attr(0644,root,root) %{_mandir}/man5/dhcp-options.5.gz
%attr(0644,root,root) %{_mandir}/man5/dhcp-eval.5.gz

%files -n dhclient-ldapresnet
%defattr(-,root,root,-)
%doc dhclient.conf.sample README.dhclient.d
%attr(0750,root,root) %dir %{dhcpconfdir}
%dir %{dhcpconfdir}/dhclient.d
%dir %{_localstatedir}/lib/dhclient
/sbin/dhclient
/sbin/dhclient-script
%{_libdir}/pm-utils
%attr(0644,root,root) %{_mandir}/man5/dhclient.conf.5.gz
%attr(0644,root,root) %{_mandir}/man5/dhclient.leases.5.gz
%attr(0644,root,root) %{_mandir}/man8/dhclient.8.gz
%attr(0644,root,root) %{_mandir}/man8/dhclient-script.8.gz
%attr(0644,root,root) %{_mandir}/man5/dhcp-options.5.gz
%attr(0644,root,root) %{_mandir}/man5/dhcp-eval.5.gz

%files devel
%defattr(-,root,root,-)
%{_includedir}/dhcpctl
%{_includedir}/isc-dhcp
%{_includedir}/omapip
%{_libdir}/libdhcpctl.a
%{_libdir}/libomapi.a
%{_libdir}/libdst.a
%attr(0644,root,root) %{_mandir}/man3/dhcpctl.3.gz
%attr(0644,root,root) %{_mandir}/man3/omapi.3.gz

%changelog
* Tue Sep 29 2009 Brian Schubert <schubert@nbcs.rutgers.edu> - 12:4.1.0p1-1.ru
- Updated to version 4.1.0p1
- Created new resnet patch for this version
- Note: Started with new spec file (from Fedora koji)

* Fri Jul 17 2009 Brian Schubert <schubert@nbcs.rutgers.edu> - 12:3.1.2p1-1.ru
- Updated to version 3.1.2p1
- Rename package to dhcp-ldapresnet
- Added ldap and resnet patches (needed to create new resnet patch)
- Added PREDEFINES and LDAPLIB to site.conf
- removed -Werror from COPTS
- Modified Requires/BuildRequires
- Modified options patch to work with 3.1.2
- Removed Fedora ldap patch and ldap patch script
- Removed warnings patch
